#ifndef _LINUX_PTRACE_H
#define _LINUX_PTRACE_H
/* ptrace.h */
/* structs and defines to help the user use the ptrace system call. */

/* has the defines to get at the registers. */

#define PTRACE_TRACEME		   0
#define PTRACE_PEEKTEXT		   1
#define PTRACE_PEEKDATA		   2
#define PTRACE_PEEKUSR		   3
#define PTRACE_POKETEXT		   4
#define PTRACE_POKEDATA		   5
#define PTRACE_POKEUSR		   6
#define PTRACE_CONT		   7
#define PTRACE_KILL		   8
#define PTRACE_SINGLESTEP	   9

#define PTRACE_ATTACH		0x10
#define PTRACE_DETACH		0x11

#define PTRACE_SYSCALL		  24

#define PTRACE_TRACEME_UMLINUX	25

#include <asm/ptrace.h>

/* UMLINUX */
struct umlinux_struct {
  int syscallState;
  int syscallType;
  int umlinuxMode;
  int syscallReturnType;
  int guestKernelSize;
  unsigned long int saved_orig_eax;
  int umlTraced;
  unsigned int limit;
  unsigned long *guestPgdList;
};

#define UML_SYSCALL_ENTER 0
#define UML_SYSCALL_RETURN 1

#define UML_UMLINUX_SYSCALL 0
#define UML_SYSTEM_SYSCALL 1

#define UML_KERNEL_MODE 0
#define UML_USER_MODE 1

#define UML_RT_SIGRETURN 1
#define UML_NOT_RT_SIGRETURN 0
/* /UMLINUX */

#endif
